#include <pt.h>

#define PT_DELAY(pt, ms, ts) \
  ts = millis(); \
  PT_WAIT_WHILE(pt, millis()-ts < (ms));

struct pt pt_taskPump;

void setup() {
  pinMode(PIN_PC0, OUTPUT); //PUMP
  pinMode(PIN_PC1, INPUT); //MOISURE SENSER
  pinMode(PIN_PC4, OUTPUT); //LED

  PT_INIT(&pt_taskPump);
}

void loop() {
   taskPump(&pt_taskPump);
}

PT_THREAD(taskPump(struct pt * pt)) {
  static uint32_t ts;
  PT_BEGIN(pt);
  while(1) {
    int moisure = analogRead(PIN_PC1);
    if (moisure <= 512 && moisure > 0) {
      digitalWrite(PIN_PC4, HIGH);
      PT_DELAY(pt, 1000, ts);
      digitalWrite(PIN_PC0, HIGH);
    } else {
      digitalWrite(PIN_PC0, LOW);
      digitalWrite(PIN_PC4, LOW);
    }
  }
  PT_END(pt);
}

